﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Freebase4net.Tests
{
    [TestClass]
    public class ImageServiceTests
    {
        private ImageService _imageService;
        private string _id;

        public ImageServiceTests()
        {
            _imageService = FreebaseServicesBuilder.CreateImageService();
            _id = "/en/the_animal";
        }

        [TestMethod]
        public void Read_Id()
        {
            string result = _imageService.GetImageUrl(_id);


            Assert.AreEqual(BaseString(), result);
        }

        [TestMethod]
        public void Read_IdAndMaxWidth()
        {
            string result = _imageService.GetImageUrl(_id, maxwidth: "150");


            Assert.AreEqual(string.Format("{0}{1}", BaseString(), "maxwidth=150&"), result);
        }

        [TestMethod]
        public void Read_IdAndMaxWidthAndMaxHeight()
        {
            string result = _imageService.GetImageUrl(_id, maxwidth: "150", maxheight: "150");


            Assert.AreEqual(string.Format("{0}{1}{2}", BaseString(), "maxheight=150&", "maxwidth=150&"), result);
        }

        [TestMethod]
        public void Read_IdAndMaxWidthAndMaxHeightAndPad()
        {
            string result = _imageService.GetImageUrl(_id, maxwidth: "150", maxheight: "150", pad: true);


            Assert.AreEqual(string.Format("{0}{1}{2}{3}", BaseString(), "maxheight=150&", "maxwidth=150&", "pad=1&"), result);
        }

        private string BaseString()
        {
            return string.Format("https://usercontent.googleapis.com/freebase/v1/image{0}?key=AIzaSyC9N5HdZl15OjRcuOFxZ1SwngjCxIebbYM&", _id);
        }
    }
}
